/* !!!! AUTOGENERATED FILE generated by svg-colormatrix.sh !!!!!  
 *                                                                
 *  Copyright 2006 Geert Jordaens <geert.jordaens@telenet.be>     
 *                                                                
 * !!!! AUTOGENERATED FILE !!!!!                                  
 *                                                                
 */
#if GEGL_CHANT_PROPERTIES
  gegl_chant_string (values, "", "list of <number>s")
#else

#define GEGL_CHANT_POINT_FILTER
#define GEGL_CHANT_NAME          svg_luminancetoalpha
#define GEGL_CHANT_DESCRIPTION   "SVG color matrix operation svg_luminancetoalpha"
#define GEGL_CHANT_CATEGORIES    "compositors:svgfilter"
#define GEGL_CHANT_SELF          "svg_luminancetoalpha.c"
#define GEGL_CHANT_PREPARE
#include "gegl-chant.h"

#include <math.h>
#include <stdlib.h>

static void prepare (GeglOperation *operation,
                     gpointer       context_id)
{
  Babl *format = babl_format ("RaGaBaA float");

  gegl_operation_set_format (operation, "input", format);
  gegl_operation_set_format (operation, "output", format);
}


static gboolean
process (GeglOperation *op,
          void          *in_buf,
          void          *out_buf,
          glong          n_pixels)
{
  gfloat      *in = in_buf;
  gfloat      *out = out_buf;
  gfloat      *m;

  gfloat ma[25] = { 0.0,      0.0,      0.0,     0.0, 0.0,
                    0.0,      0.0,      0.0,     0.0, 0.0,
                    0.0,      0.0,      0.0,     0.0, 0.0,
                    0.2125,   0.7154,   0.0721,  0.0, 0.0,
                    0.0,      0.0,      0.0,     0.0, 1.0};
  glong        i;

  m = ma;
  for (i=0; i<n_pixels; i++)
    {
      out[0] =  m[0]  * in[0] +  m[1]  * in[1] + m[2]  * in[2] + m[3]  * in[3] + m[4];
      out[1] =  m[5]  * in[0] +  m[6]  * in[1] + m[7]  * in[2] + m[8]  * in[3] + m[9];
      out[2] =  m[10] * in[0] +  m[11] * in[1] + m[12] * in[2] + m[13] * in[3] + m[14];
      out[3] =  m[15] * in[0] +  m[16] * in[1] + m[17] * in[2] + m[18] * in[3] + m[19];
      in  += 4;
      out += 4;
    }
  return TRUE;
}

#endif
